<template>
  <div class="container">
    <div>
      <b-table
        hover
        :items="items"
        :fields="fields"
        :tbody-tr-class="rowClass"
        @row-dblclicked="onRowDblClicked">
      </b-table>
    </div>

    <b-card
      border-variant="grey"
      header-text-variant="white"
      align="left"
    >
      <b-card-text>Account: {{ account}}</b-card-text>
    </b-card>

    <!-- Modal Component -->
    <b-modal ref="transaction-details-modal" id="modal-1" title="Transaction details">
      <p>Amount: <span>{{ selectedItem.amount}}</span></p>
      <p>Type: <span>{{ selectedItem.type}}</span></p>
      <p>Account number: <span>{{ selectedItem.account_number}}</span></p>
      <p>Merchant: <span>{{ selectedItem.merchant}}</span></p>
    </b-modal>
  </div>
</template>

<script>
  import http from '../services/http'

  export default {
    data() {
      return {
        account: 0,
        fields: [
          {
            key: 'type',
            sortable: true
          },
          {
            key: 'amount',
            sortable: false
          }
        ],
        items: [],
        selectedItem: {}
      }
    },
    created () {
      this.getTransactions()
    },
    methods: {
      async getTransactions() {
        const {
          data: {
            items,
            account
          }
        } = await http.get('http://localhost:3000/transactions')

        this.items = items;
        this.account = account;
      },
      onRowDblClicked (item) {
        this.selectedItem = item;
        this.$refs['transaction-details-modal'].show();
      },
      rowClass (item) {
        if (!item) return;
        if (item.type === 'debit') return 'table-success';
        if (item.type === 'credit') return 'table-danger';
      }
    }
  }
</script>
